#include <bgtu/computer_graphics_lab_work/renderer_api/point.hpp>
#include <bgtu/computer_graphics_lab_work/renderer_api/color.hpp>
#include <bgtu/computer_graphics_lab_work/utilities/shapes/rectangle.hpp>
#include <bgtu/computer_graphics_lab_work/utilities/default_renderer_linear.hpp>

namespace BGTU::ComputerGraphicsLabWork::Utilities {
	void DefaultVoxelDrawerCache::VoxelPainterImpl::fill_rectangle(
			RendererApi::PointI<2>::component_t left,
			RendererApi::PointI<2>::component_t top,
			RendererApi::PointI<2>::component_t right,
			RendererApi::PointI<2>::component_t bottom,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		if (left < 0) left = 0;
		if (top < 0) top = 0;
		if (right >= this->_width) right = this->_width;
		if (bottom >= this->_height) bottom = this->_height;

		Shapes::iterate_rectangle_fill_pp<false>(
				left, top, right, bottom,
				[=, this](RendererApi::PointI<2>::component_t x, RendererApi::PointI<2>::component_t y) {
					this->_add_voxel(x, y, z, fill, owner);
				}
		);
	}


	void DefaultVoxelDrawerCache::VoxelPainterImpl::draw_h_line(
			RendererApi::PointI<2>::component_t y,
			RendererApi::PointI<2>::component_t left,
			RendererApi::PointI<2>::component_t right,
			double z,
			RendererApi::Color::Transparent color,
			RendererApi::SpriteMetadata *owner
	) {
		if (y < 0 || y >= this->_height) return;
		if (left < 0) left = 0;
		if (right >= this->_width) right = this->_width;

		for (RendererApi::PointI<2>::component_t x = left; x < right; x++) {
			this->_add_voxel(x, y, z, color, owner);
		}
	}
}